from google.protobuf import struct_pb2 as _struct_pb2
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar, Mapping, Optional, Union

ADDRESS_FAMILY_TYPE_INVALID: AddressFamilyType
ADDRESS_FAMILY_TYPE_V4: AddressFamilyType
ADDRESS_FAMILY_TYPE_V6: AddressFamilyType
ALG_FLOW_TYPE_CONTROL: AlgFlowType
ALG_FLOW_TYPE_DATA: AlgFlowType
ALG_FLOW_TYPE_INVALID: AlgFlowType
ALG_TYPE_DCERPC: AlgType
ALG_TYPE_FTP: AlgType
ALG_TYPE_INVALID: AlgType
ALG_TYPE_ORACLE: AlgType
ALG_TYPE_SUNRPC: AlgType
ALG_TYPE_TFTP: AlgType
COMPUTE_TYPE_INVALID: ComputeType
COMPUTE_TYPE_IP: ComputeType
COMPUTE_TYPE_PHYSICAL_SERVER: ComputeType
COMPUTE_TYPE_VM: ComputeType
DESCRIPTOR: _descriptor.FileDescriptor
FLOW_ACTION_TYPE_ALLOWED: FlowActionType
FLOW_ACTION_TYPE_BLOCKED: FlowActionType
FLOW_ACTION_TYPE_INVALID: FlowActionType
FLOW_ACTION_TYPE_UNPROTECTED: FlowActionType
IP_MASK_TYPE_INVALID: IpMaskType
IP_MASK_TYPE_PRIVATE: IpMaskType
IP_MASK_TYPE_PUBLIC: IpMaskType
IP_TYPE_BCAST: IpType
IP_TYPE_INVALID: IpType
IP_TYPE_MCAST: IpType
IP_TYPE_UCAST: IpType
PROTOCOL_TYPE_ESP: ProtocolType
PROTOCOL_TYPE_GRE: ProtocolType
PROTOCOL_TYPE_INVALID: ProtocolType
PROTOCOL_TYPE_SCTP: ProtocolType
PROTOCOL_TYPE_TCP: ProtocolType
PROTOCOL_TYPE_UDP: ProtocolType
RECORD_TYPE_ACTIVE: RecordType
RECORD_TYPE_DROP: RecordType
RECORD_TYPE_INACTIVE: RecordType
RECORD_TYPE_INVALID: RecordType

class ApplicationProtocolMsg(_message.Message):
    __slots__ = ["protocol"]
    PROTOCOL_FIELD_NUMBER: ClassVar[int]
    protocol: str
    def __init__(self, protocol: Optional[str] = ...) -> None: ...

class ComputeMsg(_message.Message):
    __slots__ = ["compute_id", "compute_type", "fqdn", "ip_address", "ip_mask", "site_id"]
    COMPUTE_ID_FIELD_NUMBER: ClassVar[int]
    COMPUTE_TYPE_FIELD_NUMBER: ClassVar[int]
    FQDN_FIELD_NUMBER: ClassVar[int]
    IP_ADDRESS_FIELD_NUMBER: ClassVar[int]
    IP_MASK_FIELD_NUMBER: ClassVar[int]
    SITE_ID_FIELD_NUMBER: ClassVar[int]
    compute_id: UuidMsg
    compute_type: ComputeType
    fqdn: FqdnMsg
    ip_address: IpAddressMsg
    ip_mask: IpMaskType
    site_id: UuidMsg
    def __init__(self, compute_type: Optional[Union[ComputeType, str]] = ..., ip_address: Optional[Union[IpAddressMsg, Mapping]] = ..., compute_id: Optional[Union[UuidMsg, Mapping]] = ..., fqdn: Optional[Union[FqdnMsg, Mapping]] = ..., site_id: Optional[Union[UuidMsg, Mapping]] = ..., ip_mask: Optional[Union[IpMaskType, str]] = ...) -> None: ...

class FqdnMsg(_message.Message):
    __slots__ = ["fqdn"]
    FQDN_FIELD_NUMBER: ClassVar[int]
    fqdn: str
    def __init__(self, fqdn: Optional[str] = ...) -> None: ...

class IpAddressMsg(_message.Message):
    __slots__ = ["address_family", "ipv4", "ipv6"]
    ADDRESS_FAMILY_FIELD_NUMBER: ClassVar[int]
    IPV4_FIELD_NUMBER: ClassVar[int]
    IPV6_FIELD_NUMBER: ClassVar[int]
    address_family: AddressFamilyType
    ipv4: int
    ipv6: bytes
    def __init__(self, address_family: Optional[Union[AddressFamilyType, str]] = ..., ipv4: Optional[int] = ..., ipv6: Optional[bytes] = ...) -> None: ...

class TypedStruct(_message.Message):
    __slots__ = ["type_url", "value"]
    TYPE_URL_FIELD_NUMBER: ClassVar[int]
    VALUE_FIELD_NUMBER: ClassVar[int]
    type_url: str
    value: _struct_pb2.Struct
    def __init__(self, type_url: Optional[str] = ..., value: Optional[Union[_struct_pb2.Struct, Mapping]] = ...) -> None: ...

class UuidMsg(_message.Message):
    __slots__ = ["left", "right"]
    LEFT_FIELD_NUMBER: ClassVar[int]
    RIGHT_FIELD_NUMBER: ClassVar[int]
    left: int
    right: int
    def __init__(self, left: Optional[int] = ..., right: Optional[int] = ...) -> None: ...

class ProtocolType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class RecordType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class AddressFamilyType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class AlgType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class AlgFlowType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class IpType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class FlowActionType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class ComputeType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class IpMaskType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
