from vmware.nsx.intelligence.core.v1 import core_types_pb2 as _core_types_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar, Iterable, Mapping, Optional, Union

DESCRIPTOR: _descriptor.FileDescriptor
DETECTOR_ACTION_BLOCK: DetectorAction
DETECTOR_ACTION_ERROR: DetectorAction
DETECTOR_ACTION_INFO: DetectorAction
DETECTOR_ACTION_INVALID: DetectorAction
DETECTOR_ACTION_LOG: DetectorAction
DETECTOR_ACTION_TEST: DetectorAction

class Connection(_message.Message):
    __slots__ = ["dst_compute", "flow", "interfaces", "is_src_relevant_host", "src_compute", "vland_id"]
    DST_COMPUTE_FIELD_NUMBER: ClassVar[int]
    FLOW_FIELD_NUMBER: ClassVar[int]
    INTERFACES_FIELD_NUMBER: ClassVar[int]
    IS_SRC_RELEVANT_HOST_FIELD_NUMBER: ClassVar[int]
    SRC_COMPUTE_FIELD_NUMBER: ClassVar[int]
    VLAND_ID_FIELD_NUMBER: ClassVar[int]
    dst_compute: str
    flow: Flow
    interfaces: _containers.RepeatedScalarFieldContainer[str]
    is_src_relevant_host: bool
    src_compute: str
    vland_id: _containers.RepeatedScalarFieldContainer[int]
    def __init__(self, flow: Optional[Union[Flow, Mapping]] = ..., src_compute: Optional[str] = ..., dst_compute: Optional[str] = ..., is_src_relevant_host: bool = ..., vland_id: Optional[Iterable[int]] = ..., interfaces: Optional[Iterable[str]] = ...) -> None: ...

class Flow(_message.Message):
    __slots__ = ["dst_ip", "dst_port", "protocol", "src_ip", "src_port"]
    DST_IP_FIELD_NUMBER: ClassVar[int]
    DST_PORT_FIELD_NUMBER: ClassVar[int]
    PROTOCOL_FIELD_NUMBER: ClassVar[int]
    SRC_IP_FIELD_NUMBER: ClassVar[int]
    SRC_PORT_FIELD_NUMBER: ClassVar[int]
    dst_ip: str
    dst_port: int
    protocol: _core_types_pb2.ProtocolType
    src_ip: str
    src_port: int
    def __init__(self, src_ip: Optional[str] = ..., dst_ip: Optional[str] = ..., dst_port: Optional[int] = ..., src_port: Optional[int] = ..., protocol: Optional[Union[_core_types_pb2.ProtocolType, str]] = ...) -> None: ...

class ListBoolean(_message.Message):
    __slots__ = ["list_boolean_value"]
    LIST_BOOLEAN_VALUE_FIELD_NUMBER: ClassVar[int]
    list_boolean_value: _containers.RepeatedScalarFieldContainer[bool]
    def __init__(self, list_boolean_value: Optional[Iterable[bool]] = ...) -> None: ...

class ListFlow(_message.Message):
    __slots__ = ["list_flow_value"]
    LIST_FLOW_VALUE_FIELD_NUMBER: ClassVar[int]
    list_flow_value: _containers.RepeatedCompositeFieldContainer[Flow]
    def __init__(self, list_flow_value: Optional[Iterable[Union[Flow, Mapping]]] = ...) -> None: ...

class ListNumber(_message.Message):
    __slots__ = ["list_number_value"]
    LIST_NUMBER_VALUE_FIELD_NUMBER: ClassVar[int]
    list_number_value: _containers.RepeatedScalarFieldContainer[float]
    def __init__(self, list_number_value: Optional[Iterable[float]] = ...) -> None: ...

class ListString(_message.Message):
    __slots__ = ["list_string_value"]
    LIST_STRING_VALUE_FIELD_NUMBER: ClassVar[int]
    list_string_value: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, list_string_value: Optional[Iterable[str]] = ...) -> None: ...

class UnionValue(_message.Message):
    __slots__ = ["json_value", "list_bool_value", "list_flow_value", "list_number_value", "list_string_value"]
    JSON_VALUE_FIELD_NUMBER: ClassVar[int]
    LIST_BOOL_VALUE_FIELD_NUMBER: ClassVar[int]
    LIST_FLOW_VALUE_FIELD_NUMBER: ClassVar[int]
    LIST_NUMBER_VALUE_FIELD_NUMBER: ClassVar[int]
    LIST_STRING_VALUE_FIELD_NUMBER: ClassVar[int]
    json_value: str
    list_bool_value: ListBoolean
    list_flow_value: ListFlow
    list_number_value: ListNumber
    list_string_value: ListString
    def __init__(self, list_number_value: Optional[Union[ListNumber, Mapping]] = ..., list_string_value: Optional[Union[ListString, Mapping]] = ..., list_bool_value: Optional[Union[ListBoolean, Mapping]] = ..., json_value: Optional[str] = ..., list_flow_value: Optional[Union[ListFlow, Mapping]] = ...) -> None: ...

class DetectorAction(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
