from vmware.nsx.intelligence.core.v1 import core_types_pb2 as _core_types_pb2
from vmware.nsx.intelligence.nta.v1 import nta_core_types_pb2 as _nta_core_types_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar, Iterable, Mapping, Optional, Union

DESCRIPTOR: _descriptor.FileDescriptor
MERGE_POLICY_INVALID: MergePolicy
MERGE_POLICY_KEEP_ORIGINAL: MergePolicy
MERGE_POLICY_OVERRIDE_EXISTING: MergePolicy
MERGE_POLICY_SET_UNION: MergePolicy
MERGE_POLICY_SET_UNION_WITH_MAX: MergePolicy
METADATA_KEY_DST_COMPUTES: MetadataKey
METADATA_KEY_DST_IPS: MetadataKey
METADATA_KEY_HOTSPOTS: MetadataKey
METADATA_KEY_INVALID: MetadataKey
METADATA_KEY_PORT: MetadataKey
METADATA_KEY_PRIMARY_CONN: MetadataKey
METADATA_KEY_PROTOCOL: MetadataKey
METADATA_KEY_SRC_COMPUTES: MetadataKey
METADATA_KEY_SRC_IPS: MetadataKey

class DataFlow(_message.Message):
    __slots__ = ["application_protocols", "dst_compute", "end_time", "server_ports", "src_compute", "start_time", "transport_protocols"]
    APPLICATION_PROTOCOLS_FIELD_NUMBER: ClassVar[int]
    DST_COMPUTE_FIELD_NUMBER: ClassVar[int]
    END_TIME_FIELD_NUMBER: ClassVar[int]
    SERVER_PORTS_FIELD_NUMBER: ClassVar[int]
    SRC_COMPUTE_FIELD_NUMBER: ClassVar[int]
    START_TIME_FIELD_NUMBER: ClassVar[int]
    TRANSPORT_PROTOCOLS_FIELD_NUMBER: ClassVar[int]
    application_protocols: _containers.RepeatedScalarFieldContainer[str]
    dst_compute: _core_types_pb2.ComputeMsg
    end_time: int
    server_ports: _containers.RepeatedScalarFieldContainer[int]
    src_compute: _core_types_pb2.ComputeMsg
    start_time: int
    transport_protocols: _containers.RepeatedScalarFieldContainer[_core_types_pb2.ProtocolType]
    def __init__(self, src_compute: Optional[Union[_core_types_pb2.ComputeMsg, Mapping]] = ..., dst_compute: Optional[Union[_core_types_pb2.ComputeMsg, Mapping]] = ..., transport_protocols: Optional[Iterable[Union[_core_types_pb2.ProtocolType, str]]] = ..., application_protocols: Optional[Iterable[str]] = ..., server_ports: Optional[Iterable[int]] = ..., start_time: Optional[int] = ..., end_time: Optional[int] = ...) -> None: ...

class Event(_message.Message):
    __slots__ = ["affected_compute", "data_flows", "detection_end_time_epoch_milli", "detection_start_time_epoch_milli", "detector_name", "event_metadata", "is_attacker", "is_client", "merge_plan", "mitre_tactic", "mitre_technique", "org_id", "score", "silent", "site_ids", "version"]
    AFFECTED_COMPUTE_FIELD_NUMBER: ClassVar[int]
    DATA_FLOWS_FIELD_NUMBER: ClassVar[int]
    DETECTION_END_TIME_EPOCH_MILLI_FIELD_NUMBER: ClassVar[int]
    DETECTION_START_TIME_EPOCH_MILLI_FIELD_NUMBER: ClassVar[int]
    DETECTOR_NAME_FIELD_NUMBER: ClassVar[int]
    EVENT_METADATA_FIELD_NUMBER: ClassVar[int]
    IS_ATTACKER_FIELD_NUMBER: ClassVar[int]
    IS_CLIENT_FIELD_NUMBER: ClassVar[int]
    MERGE_PLAN_FIELD_NUMBER: ClassVar[int]
    MITRE_TACTIC_FIELD_NUMBER: ClassVar[int]
    MITRE_TECHNIQUE_FIELD_NUMBER: ClassVar[int]
    ORG_ID_FIELD_NUMBER: ClassVar[int]
    SCORE_FIELD_NUMBER: ClassVar[int]
    SILENT_FIELD_NUMBER: ClassVar[int]
    SITE_IDS_FIELD_NUMBER: ClassVar[int]
    VERSION_FIELD_NUMBER: ClassVar[int]
    affected_compute: _core_types_pb2.ComputeMsg
    data_flows: _containers.RepeatedCompositeFieldContainer[DataFlow]
    detection_end_time_epoch_milli: int
    detection_start_time_epoch_milli: int
    detector_name: str
    event_metadata: EventMetadata
    is_attacker: bool
    is_client: bool
    merge_plan: MergePlan
    mitre_tactic: str
    mitre_technique: str
    org_id: str
    score: Score
    silent: bool
    site_ids: _containers.RepeatedScalarFieldContainer[str]
    version: str
    def __init__(self, version: Optional[str] = ..., detector_name: Optional[str] = ..., detection_start_time_epoch_milli: Optional[int] = ..., detection_end_time_epoch_milli: Optional[int] = ..., score: Optional[Union[Score, Mapping]] = ..., event_metadata: Optional[Union[EventMetadata, Mapping]] = ..., merge_plan: Optional[Union[MergePlan, Mapping]] = ..., mitre_tactic: Optional[str] = ..., mitre_technique: Optional[str] = ..., silent: bool = ..., site_ids: Optional[Iterable[str]] = ..., org_id: Optional[str] = ..., affected_compute: Optional[Union[_core_types_pb2.ComputeMsg, Mapping]] = ..., is_attacker: bool = ..., is_client: bool = ..., data_flows: Optional[Iterable[Union[DataFlow, Mapping]]] = ...) -> None: ...

class EventMetadata(_message.Message):
    __slots__ = ["kv_store"]
    class KvStoreEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: ClassVar[int]
        VALUE_FIELD_NUMBER: ClassVar[int]
        key: str
        value: _nta_core_types_pb2.UnionValue
        def __init__(self, key: Optional[str] = ..., value: Optional[Union[_nta_core_types_pb2.UnionValue, Mapping]] = ...) -> None: ...
    KV_STORE_FIELD_NUMBER: ClassVar[int]
    kv_store: _containers.MessageMap[str, _nta_core_types_pb2.UnionValue]
    def __init__(self, kv_store: Optional[Mapping[str, _nta_core_types_pb2.UnionValue]] = ...) -> None: ...

class MergePlan(_message.Message):
    __slots__ = ["dedup_key", "metadata_key_merge_operation"]
    class MetadataKeyMergeOperationEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: ClassVar[int]
        VALUE_FIELD_NUMBER: ClassVar[int]
        key: str
        value: MergePolicy
        def __init__(self, key: Optional[str] = ..., value: Optional[Union[MergePolicy, str]] = ...) -> None: ...
    DEDUP_KEY_FIELD_NUMBER: ClassVar[int]
    METADATA_KEY_MERGE_OPERATION_FIELD_NUMBER: ClassVar[int]
    dedup_key: str
    metadata_key_merge_operation: _containers.ScalarMap[str, MergePolicy]
    def __init__(self, dedup_key: Optional[str] = ..., metadata_key_merge_operation: Optional[Mapping[str, MergePolicy]] = ...) -> None: ...

class NtaAlert(_message.Message):
    __slots__ = ["action", "affected_compute", "data_flows", "detector_name", "end_time", "event_id", "evidence", "impact", "is_attacker", "is_client", "mitre_tactic", "mitre_technique", "occurrence", "primary_connection", "score", "start_time"]
    ACTION_FIELD_NUMBER: ClassVar[int]
    AFFECTED_COMPUTE_FIELD_NUMBER: ClassVar[int]
    DATA_FLOWS_FIELD_NUMBER: ClassVar[int]
    DETECTOR_NAME_FIELD_NUMBER: ClassVar[int]
    END_TIME_FIELD_NUMBER: ClassVar[int]
    EVENT_ID_FIELD_NUMBER: ClassVar[int]
    EVIDENCE_FIELD_NUMBER: ClassVar[int]
    IMPACT_FIELD_NUMBER: ClassVar[int]
    IS_ATTACKER_FIELD_NUMBER: ClassVar[int]
    IS_CLIENT_FIELD_NUMBER: ClassVar[int]
    MITRE_TACTIC_FIELD_NUMBER: ClassVar[int]
    MITRE_TECHNIQUE_FIELD_NUMBER: ClassVar[int]
    OCCURRENCE_FIELD_NUMBER: ClassVar[int]
    PRIMARY_CONNECTION_FIELD_NUMBER: ClassVar[int]
    SCORE_FIELD_NUMBER: ClassVar[int]
    START_TIME_FIELD_NUMBER: ClassVar[int]
    action: _nta_core_types_pb2.DetectorAction
    affected_compute: _core_types_pb2.ComputeMsg
    data_flows: _containers.RepeatedCompositeFieldContainer[DataFlow]
    detector_name: str
    end_time: int
    event_id: str
    evidence: EventMetadata
    impact: int
    is_attacker: bool
    is_client: bool
    mitre_tactic: str
    mitre_technique: str
    occurrence: int
    primary_connection: _nta_core_types_pb2.Connection
    score: Score
    start_time: int
    def __init__(self, event_id: Optional[str] = ..., action: Optional[Union[_nta_core_types_pb2.DetectorAction, str]] = ..., detector_name: Optional[str] = ..., start_time: Optional[int] = ..., end_time: Optional[int] = ..., occurrence: Optional[int] = ..., score: Optional[Union[Score, Mapping]] = ..., primary_connection: Optional[Union[_nta_core_types_pb2.Connection, Mapping]] = ..., evidence: Optional[Union[EventMetadata, Mapping]] = ..., mitre_tactic: Optional[str] = ..., mitre_technique: Optional[str] = ..., impact: Optional[int] = ..., affected_compute: Optional[Union[_core_types_pb2.ComputeMsg, Mapping]] = ..., is_attacker: bool = ..., is_client: bool = ..., data_flows: Optional[Iterable[Union[DataFlow, Mapping]]] = ...) -> None: ...

class Score(_message.Message):
    __slots__ = ["confidence", "severity"]
    CONFIDENCE_FIELD_NUMBER: ClassVar[int]
    SEVERITY_FIELD_NUMBER: ClassVar[int]
    confidence: int
    severity: int
    def __init__(self, confidence: Optional[int] = ..., severity: Optional[int] = ...) -> None: ...

class MergePolicy(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []

class MetadataKey(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
